#include <list>
#include <pthread.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/time.h>

typedef struct _Param
{
  int callCnt;
  int loopCnt;
  int threadCnt;
} Param;

void foo(int loopCnt)
{
  int cnt = loopCnt;
  for (int i = 0; i < cnt; i++);
}

void* threadProc(void* p)
{
  Param* param = (Param*)p;

  int callCnt = param->callCnt;
  int loopCnt = param->loopCnt;

  struct timeval begTick; gettimeofday(&begTick, NULL);
  
  for (int i = 0; i < callCnt; i++)
  {
    foo(loopCnt);
  }
  
  struct timeval endTick; gettimeofday(&endTick, NULL);

  printf("%ld\n", (endTick.tv_sec - begTick.tv_sec) * 1000 + (endTick.tv_usec - begTick.tv_usec) / 1000);
  return NULL;
}

void usage()
{
  printf("test <call count> <loop count> <thread count>\n");
  printf("example : test 100 100 2\n");
}

int main(int argc, char* argv[])
{
  if (argc != 4)
  {
    usage();
    return 0;
  }

  Param param;

  param.callCnt   = atoi(argv[1]);
  param.loopCnt   = atoi(argv[2]);
  param.threadCnt = atoi(argv[3]);

  std::list<pthread_t> threadList;

  for (int i = 0; i < param.threadCnt; i++)
  {
    pthread_t threadHandle;
    pthread_create(&threadHandle, NULL, threadProc, (void *)&param);
    threadList.push_back(threadHandle);
  }

  for (std::list<pthread_t>::iterator it = threadList.begin(); it != threadList.end(); it++)
  {
    pthread_t threadHandle = *it;
    pthread_join(threadHandle, NULL);
  }

  threadList.clear();
  return 0;
}
