#include <conio.h>
#include <list>
#include <stdio.h>
#include <windows.h>

typedef struct _Param
{
  int callCnt;
  int loopCnt;
  int threadCnt;
} Param;

void foo(int loopCnt)
{
  int cnt = loopCnt;
  for (int i = 0; i < cnt; i++);
}

DWORD __stdcall threadProc(LPVOID p)
{
  Param* param = (Param*)p;

  int callCnt = param->callCnt;
  int loopCnt = param->loopCnt;

  DWORD begTick = GetTickCount();
  
  for (int i = 0; i < callCnt; i++)
  {
    foo(loopCnt);
  }
  
  DWORD endTick = GetTickCount();

  printf("%d\n", endTick - begTick);
  return 0;
}

void usage()
{
  printf("test <call count> <loop count> <thread count>\n");
  printf("example : test 100 100 2\n");
}

int main(int argc, char* argv[])
{
  if (argc != 4)
  {
    usage();
    return 0;
  }

  Param param;

  param.callCnt   = atoi(argv[1]);
  param.loopCnt   = atoi(argv[2]);
  param.threadCnt = atoi(argv[3]);

  std::list<HANDLE> threadList;

  for (int i = 0; i < param.threadCnt; i++)
  {
    DWORD threadID;
    HANDLE threadHandle = 
      CreateThread(
        NULL,
        0,
        &threadProc,
        &param,
        0,
        &threadID);
    threadList.push_back(threadHandle);
  }

  for (std::list<HANDLE>::iterator it = threadList.begin(); it != threadList.end(); it++)
  {
    HANDLE threadHandle = *it;
    WaitForSingleObject(threadHandle, INFINITE);
  }

  threadList.clear();
  return 0;
}
